<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Factor/Abstract/Bool.php';

class Ssc_Service_SeoScore_Factor_UrlContain
    extends Ssc_Service_SeoScore_Factor_Abstract_Bool
{
    protected $_label = 'Permalink contains primary keyword.';

    public function analyze($service)
    {
        $keyword = $service->purifyWords($service->getAnalyzeData('primary'));
        $url = $service->getAnalyzeData('url');

        $urlParts = @parse_url($url);
        if (FALSE === $urlParts) {
            // Malformed URL
            return $this->setValue(FALSE);
        }

        if (isset($urlParts['path'])
            && $this->keywordInUrlFragment($service, $urlParts['path'], $keyword)
        ) {
            return $this->setValue(TRUE);
        }
        if (isset($urlParts['host'])
            && $this->keywordInUrlFragment($service, $urlParts['host'], $keyword)
        ) {
            return $this->setValue(TRUE);

        }

        return $this->setValue(FALSE);
    }

    public function keywordInUrlFragment($service, $fragment, $keyword)
    {
        return $service->keywordInText($this->_filterUrl($service, $fragment), $keyword);
    }

    protected function _filterUrl($service, $url)
    {
        return $service->purifyWords(urldecode($url));
    }
}
