<?php
require_once SSC_APPLICATION_PATH . '/services/SeoScore/Helper/Abstract/Base.php';

class Ssc_Service_SeoScore_Helper_AnalyzeWords
    extends Ssc_Service_SeoScore_Helper_Abstract_Base
{
    protected $_result;

    public function direct($service, $key)
    {
        if (is_null($this->_result)) {
            $text = $service->getAnalyzeData('post_text');

            $keywords = $service->getAnalyzeData('secondary');
            array_unshift($keywords, $service->getAnalyzeData('primary'));

            foreach ($keywords as $i=>$keyword) {
                $keywords[$i] = preg_quote($keyword, '~');
            }

            $keywordCount = preg_match_all('~(?:^|[^\w\d])(?:' . implode('|', $keywords) . ')(?:$|[^\w\d])~iu',
                $text, $matches);
            $wordCount = preg_match_all('~\b\w+?\b~u', $text, $matches, PREG_OFFSET_CAPTURE|PREG_PATTERN_ORDER);

            if (0 != $wordCount) {
                $density = $keywordCount / $wordCount;
            } else {
                $density = 0;
            }

            $this->_result = array(
                'keyword_count' => $keywordCount,
                'word_count' => $wordCount,
                'keyword_density' => $density,
                'keyword_density_percent' => $density * 100,
                'word_postitions' => $matches[0],
            );
        }

        if (!is_null($key)) {
            return isset($this->_result[$key])? $this->_result[$key] : NULL;
        }

        return $this->_result;
    }
}
