jQuery(function($) {
    $('.ssc_metabox-button_update').click(function() {
        if (!ssc_validate()) {
            return;
        }

        this.disabled = true;
        $(this).addClass('button-primary-disabled');
        $('#ssc_metabox-update_ajax_loader').css('visibility', 'visible');
        blockSave = true;
        window.onbeforeunload = null;
        $('#post').submit();
    });

    $('.ssc_metabox-lsi_suggest').click(function() {
        var maxResults = 25;

        if (!ssc_validate()) {
            return;
        }

        this.disabled = true;
        $(this).addClass('button-disabled');
        $('#ssc_metabox-lsi_ajax_loader').css('visibility', 'visible');

        $('#ssc_metabox .ssc_metabox-lsi_list').hide();
        $('#ssc_metabox .ssc_metabox-lsi_list_placeholder ul').remove();
        var element = $('#ssc_metabox .ssc_metabox-lsi_list_placeholder');
        if ($('#ssc_metabox .ssc_metabox-lsi_list_placeholder').css('display') == 'none') {
            $('#ssc_metabox .ssc_metabox-lsi_list_control').click();
        }

        var existingKeywords = $("#ssc_secondary").val().split("\n");
        for (i = 0; i < existingKeywords.length; i++) {
            keyword = $.trim(existingKeywords[i]).toLowerCase();
            if ('' == keyword) {
                existingKeywords.splice(i, 1);
                i--;
                continue;
            }
            existingKeywords[i] = keyword;
        }
        var keyword = $.trim($("#ssc_primary").val());
        existingKeywords.push(keyword);

        // Request Bing API
        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: {
                action:             'ssc',
                controller:         'metabox',
                controller_action:  'related-terms',
                keyword:            keyword
            },
            dataType: 'json',

            success: function(data) {
                // No Related Keywords
                if(undefined === data['result'] || 0 == data['result'].length) {
                    if (undefined !== data['error']) {
                        alert(data['error']);
                    } else {
                        alert('Sorry, found no LSI keywords for \'' + keyword + '\'.');
                    }

                    return;
                }

                response = data['result'];

                // Remove existing keywords
                var keywords = [];
                for (i = 0; i < response.length; i++) {
                    keyword = $.trim(response[i]);
                    if ($.inArray(keyword.toLowerCase(), existingKeywords) >= 0) {
                        response.splice(i, 1);
                        i--;
                        continue;
                    }
                    keywords.push(keyword);
                    if (keywords.length >= maxResults) {
                        break;
                    }
                }

                if (0 == keywords.length) {
                    alert('Sorry, you already used all LSI keywords found for \'' + keyword + '\'.');
                    return;
                }

                var output = '<ul>';
                for (i in keywords) {
                    output += '<li>' + ssc_htmlEscape(keywords[i]) + '</li>';
                }
                output += '</ul>';

                $('#ssc_metabox .ssc_metabox-lsi_list_placeholder').append(output);

                $('#ssc_metabox .ssc_metabox-lsi_list_placeholder ul li').click(function() {
                    var field = $('#ssc_secondary');
                    var val =  $.trim(field.val());
                    if ('' != val) {
                        val += "\n";
                    }
                    val += $(this).text();
                    field.val(val);
                    $(this).remove();

                    if (0 == $('#ssc_metabox .ssc_metabox-lsi_list_placeholder ul li').length) {
                        $('#ssc_metabox .ssc_metabox-lsi_list').slideUp();
                    }
                });

                $('#ssc_metabox .ssc_metabox-lsi_list').slideDown();
            },

            error: function(jqXHR, textStatus, errorThrown) {
                alert('AJAX error while requesting LSI keywords');
            },

            complete: function() {
                $('.ssc_metabox-lsi_suggest').prop('disabled', false)
                    .removeClass('button-disabled');
                $('#ssc_metabox-lsi_ajax_loader').css('visibility', 'hidden');
            }

        }); // ajax() ends
    });

    $('.ssc_metabox-lsi_list_control').click(function() {
        var element = $('#ssc_metabox .ssc_metabox-lsi_list_placeholder');
        if (element.css('display') != 'none') {
            element.slideUp(function() {
                $('.ssc_metabox-lsi_list_control').text('Show LSI suggestions')
                    .css('height', 'auto')
                    .css('float', 'none');
            });
        } else {
            element.slideDown();
            $(this).text('Hide')
                .css('height', '')
                .css('float', '');
        }
        return false;
    });

    function ssc_validate()
    {
        var result = $('#ssc_primary').val()? true : false;
        if (!result) {
            ssc_show_message('Please specify primary keyword', 'error');
            $('#ssc_primary').focus();
        }

        if (result) {
            ssc_remove_message();
        }

        return result;
    }

    function ssc_show_message(message, type)
    {
        ssc_remove_message();
        $('#ssc_metabox .ssc_metabox-message').append('<li class="' + type + '">' + message + '</li>');
    }

    function ssc_remove_message()
    {
        $('#ssc_metabox .ssc_metabox-message').empty();
    }

    function ssc_htmlEscape(string) {
        return string.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
    }
});